local json = require("json")
local utils = require("utils")
local utils_device = require("utils_device")

local request_method = ngx.var.request_method

utils.check_login()
utils.check_permission("DeviceManage")

if ("POST" == request_method) then
    local utils_header = require("utils_header")
    local params = utils_header.check_public_boby_data()
    local pk = params["productKey"]
    local dn = params["deviceName"]
    local property_list = params["properties"]
    
    if (not (pk and dn and property_list)) then
        utils.error_exit(400, "invalid parameter")
    end
    
    local new_property = string.sub(json.encode(property_list), 2, #property_list - 1) 
    
    utils.log_info("set property params: "..new_property)

    ret = utils_device.set_property_value(pk, dn, new_property)
    if (not ret) then
        utils.error_exit(500, "set data into device failed")
    end
    --FIXME: should change to null.
    utils.error_exit(200, "null")
end

utils.error_exit(400, "unsupported request method")
